//
//  ApplicationController.m
//  BlendingModes
//
//  Created by Patrick Geiller on 05/06/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "ApplicationController.h"
#import "BlendingMode.h"

@implementation ApplicationController

- (void)awakeFromNib
{
	blendingModes = [[NSMutableArray alloc] init];

	
	NSArray* modes = [NSArray arrayWithObjects:
								@"CISourceAtopCompositing",
								@"CIAdditionCompositing",
								@"CIColorBlendMode",
								@"CIColorBurnBlendMode",
								@"CIColorDodgeBlendMode",
								@"CIDarkenBlendMode",
								@"CIDifferenceBlendMode",
								@"CIExclusionBlendMode",
								@"CIHardLightBlendMode",
								@"CIHueBlendMode",
								@"CILightenBlendMode",
								@"CILuminosityBlendMode",
								@"CIMaximumCompositing",
								@"CIMinimumCompositing",
								@"CIMultiplyBlendMode",
								@"CIMultiplyCompositing",
								@"CIOverlayBlendMode",
								@"CISaturationBlendMode",
								@"CIScreenBlendMode",
								@"CISoftLightBlendMode",
								@"CISourceAtopCompositing",
								@"CISourceInCompositing",
								@"CISourceOutCompositing",
								@"CISourceOverCompositing",
								nil];
	for (id o in modes) 
		[self addBlendingMode:o];
		
	[layerView bind:@"blendingMode" toObject:modesController withKeyPath:@"selection.name" options:nil];
	[opacitySlider bind:@"value" toObject:layerView withKeyPath:@"opacity" options:nil];
	[opacitySlider setContinuous:YES];
}

- (void)addBlendingMode:(NSString*)modeName
{
	BlendingMode*	mode = [[BlendingMode alloc] init];
	mode.name = modeName;

	NSIndexSet* insertedIndexes = [NSIndexSet indexSetWithIndex:[blendingModes count]];
	[self willChange:NSKeyValueChangeInsertion valuesAtIndexes:insertedIndexes forKey:@"blendingModes"];
	[blendingModes addObject:mode];
	[self didChange:NSKeyValueChangeInsertion valuesAtIndexes:insertedIndexes forKey:@"blendingModes"];
}


@end
