//
//  LayerView.m
//  BlendingModes
//
//  Created by Patrick Geiller on 05/06/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "LayerView.h"
#import <QuartzCore/QuartzCore.h>

@implementation LayerView

@synthesize blendingMode, opacity;


- (void)awakeFromNib
{
	[self setWantsLayer:YES];
	
	backLayer	= [CALayer layer];
	
	[self.layer addSublayer:backLayer];
	
	
	NSString*			path;
	CGDataProviderRef	provider;
	CGImageRef			image;
	path = [[NSBundle mainBundle] pathForImageResource:@"Back.jpg"];
	provider = CGDataProviderCreateWithURL( (CFURLRef)([NSURL fileURLWithPath:path]) );
	image = CGImageCreateWithJPEGDataProvider(provider, nil, true, kCGRenderingIntentDefault);
	backLayer.contents = (id)image;
    CGDataProviderRelease (provider);
	
	backLayer.anchorPoint = CGPointMake(0, 0);
	backLayer.bounds = CGRectMake(0,0, CGImageGetWidth(image), CGImageGetHeight(image));


	frontLayer	= [CALayer layer];
	
	[self.layer addSublayer:frontLayer];
	
	
	path = [[NSBundle mainBundle] pathForImageResource:@"Front.jpg"];
	provider = CGDataProviderCreateWithURL( (CFURLRef)([NSURL fileURLWithPath:path]) );
	image = CGImageCreateWithJPEGDataProvider(provider, nil, true, kCGRenderingIntentDefault);
	frontLayer.contents = (id)image;
    CGDataProviderRelease (provider);
	
	frontLayer.bounds = CGRectMake(0,0, CGImageGetWidth(image), CGImageGetHeight(image));
	frontLayer.position = CGPointMake(300, 200);
	frontLayer.opacity = 0;
	
	[self setValue:[NSNumber numberWithFloat:0] forKey:@"opacity"];
	
	[self performSelector:@selector(appear) withObject:nil afterDelay:0];
}

- (void)appear
{
	[self setValue:[NSNumber numberWithFloat:1] forKey:@"opacity"];	
}

- (void)setBlendingMode:(NSString*)modeName;
{
	CIFilter* filter = [CIFilter filterWithName:modeName];
	frontLayer.compositingFilter = filter;
}

- (void)setOpacity:(float)t
{
	frontLayer.opacity = t;
}

- (void)mouseDown:(NSEvent *)theEvent
{
	frontLayer.position = NSPointToCGPoint([self convertPoint:theEvent.locationInWindow fromView:nil]);
}
- (void)mouseDragged:(NSEvent *)theEvent
{
	[CATransaction setValue:[NSNumber numberWithFloat:0] forKey:kCATransactionAnimationDuration];
	frontLayer.position = NSPointToCGPoint([self convertPoint:theEvent.locationInWindow fromView:nil]);
	[CATransaction commit];
}

@end
